{% extends 'base.html' %}
{% load static %}

{% block content %}
<div>
    <form id="add-entry" method="post" enctype='multipart/form-data'>{% csrf_token %}
        {{ form.as_p }}

        {% if appname == 'articlesummaries' or appname == 'projectsummaries' %}
        <h3>Upload Images</h3>
        {{ images.management_form }}
        {{ images.non_form_errors }}
        <div id="image-forms">
            {% for formset in images %}
                <div class="form-group">
                    {% if formset.instance.pk %}{{ formset.id }}{% endif %}
                    {{ formset.image.label_tag }} {{ formset.image }}
                    {{ formset.caption.label_tag }} {{ formset.caption }}
                    {% if formset.instance.image %}
                        <p>Current image: <a href="{{ formset.instance.image.url }}">{{ formset.instance.image.url }}</a></p>
                        <button type="button" class="delete-button" data-target="{{ formset.prefix }}-DELETE">Delete</button>
                        <input type="checkbox" name="{{ formset.prefix }}-DELETE" id="{{ formset.prefix }}-DELETE" style="display: none;">
                        {{ formset.DELETE }}
                    {% endif %}
                </div>
            {% endfor %}
        </div>
        <button type="button" id="add-image-form" class="btn btn-secondary mb-4">Add another image</button>
        
        <h3>Upload PDFs</h3>
        {{ pdfs.management_form }}
        {{ pdfs.non_form_errors }}
        <div id="pdf-forms">
            {% for formset in pdfs %}
                <div class="form-group">
                    {% if formset.instance.pk %}{{ formset.id }}{% endif %}
                    {{ formset.pdf.label_tag }} {{ formset.pdf }}
                    {{ formset.description.label_tag }} {{ formset.description }}
                    {% if formset.instance.pdf %}
                    <p>Current PDF: <a href="{{ formset.instance.pdf.url }}">{{ formset.instance.pdf.url }}</a></p>
                    <button type="button" class="delete-button" data-target="{{ formset.prefix }}-DELETE">Delete</button>
                    <input type="checkbox" name="{{ formset.prefix }}-DELETE" id="{{ formset.prefix }}-DELETE" style="display: none;">
                    {{ formset.DELETE }}
                    {% endif %}
                </div>
            {% endfor %}
        </div>
        <button type="button" id="add-pdf-form" class="btn btn-secondary mb-4">Add another PDF</button>
        {% endif %}

        {% if appname == 'educationalcontent' %}
        <div class="spacer-div"></div>
        <p><strong>Files and videos can be added after creating the course.</strong></p>
        <div class="spacer-div"></div>
        {% endif %}
        
        <!-- submit and cancel buttons -->
        <div class="spacer-div"></div>
        <a class="link-button form-cancel-button" href="javascript:history.back()">Cancel</a>
        <input type="submit" value="Submit">
    </form>
</div>

<!-- JavaScript -->
<script type="text/javascript" src="{% static 'assets/transparency/js/create_areaSelects.js' %}"></script>

{% if appname == 'articlesummaries' or appname == 'projectsummaries' %}
<script type="text/javascript" src="{% static 'assets/transparency/js/create_imageCaption.js' %}"></script>
{% endif %}

<script type="text/javascript">
    function updateFormIndex(element, prefix) {
        var currentIndex = parseInt(element.querySelector('input').name.match(/\d+/)[0]);
        var newIndex = document.querySelectorAll(`#${prefix}-forms .form-group`).length;
        element.querySelectorAll('input, select, textarea').forEach(function(input) {
            input.name = input.name.replace(currentIndex, newIndex);
            input.id = input.id.replace(currentIndex, newIndex);
            if (input.type !== 'hidden') {
                input.value = '';
            }
        });
        return element;
    }

    document.getElementById('add-image-form').addEventListener('click', function(e) {
        e.preventDefault();
        var formIdx = document.querySelectorAll('#image-forms .form-group').length;
        var newForm = updateFormIndex(document.querySelector('#image-forms .form-group').cloneNode(true), 'image');
        newForm.querySelector('p')?.remove(); // Remove the "Current image" paragraph if it exists
        document.getElementById('image-forms').appendChild(newForm);
        document.querySelector('#id_images-TOTAL_FORMS').value = formIdx + 1;
    });
    
    document.getElementById('add-pdf-form').addEventListener('click', function(e) {
        e.preventDefault();
        var formIdx = document.querySelectorAll('#pdf-forms .form-group').length;
        var newForm = updateFormIndex(document.querySelector('#pdf-forms .form-group').cloneNode(true), 'pdf');
        newForm.querySelector('p')?.remove(); // Remove the "Current PDF" paragraph if it exists
        document.getElementById('pdf-forms').appendChild(newForm);
        document.querySelector('#id_pdfs-TOTAL_FORMS').value = formIdx + 1;
    });
</script>

<script>
    document.addEventListener('click', function(event) {
        if (event.target.classList.contains('delete-button')) {
            var targetInput = document.querySelector(`input[name="${event.target.dataset.target}"]`);
            var formGroup = event.target.closest('.form-group');
            if (targetInput) {
                targetInput.checked = !targetInput.checked;
                if (targetInput.checked) {
                    formGroup.style.opacity = '0.5';
                } else {
                    formGroup.style.opacity = '1';
                }
            }
        }
    });
</script>

{% endblock %}
